﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;

using System.Text;
using System.Windows.Forms;

namespace SumNumberMatch
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void btnCalc_Click(object sender, EventArgs e)
        {
            decimal tsum = 0;
            if (!Decimal.TryParse(txbSumNumber.Text, out tsum))
            {
                MessageBox.Show("Please confirm your Sum number is a number:" + txbSumNumber.Text);
                return;
            }
            long sum = Convert.ToInt64(tsum*100);
            var lines = rtbNumberList.Text.Split(new[] {'\r', '\n'}, StringSplitOptions.RemoveEmptyEntries);
            var list=new List<long>();
            foreach (var line in lines)
            {
                decimal row = 0;
                Decimal.TryParse(line, out row);
                if (row != 0&& row<=sum)
                {
                    list.Add(Convert.ToInt64(row*100));//换成整数节约内存
                }
                else
                {
                    MessageBox.Show("Please confirm your input is a number:" + row);
                    return;
                }
            }
           
            rtbResult.Clear();
            for (var i = 1; i < list.Count; i++)//取I个元素，进行组合，然后计算
            {
                List<long[]> result = PermutationAndCombination.GetCombination(list.ToArray(), i,sum);
                foreach (var array in result)
                {
                    if (Sum(array) == sum)
                    {
                        rtbResult.AppendText(JoinDecimal(array));
                        rtbResult.AppendText("-----------\r\n");
                    }
                }
                //MessageBox.Show(i.ToString());
            }
            MessageBox.Show("End");
        }

        private decimal Sum(long[] array)
        {
            decimal r = 0;
            foreach (var d in array)
            {
                r += d;
            }
            return r;
        }

        private string JoinDecimal(long[] array)
        {
            StringBuilder sb=new StringBuilder();
            foreach (var d in array)
            {
                sb.Append(Convert.ToDecimal(d/100.00m).ToString());
                sb.Append("\r\n");
            }
            return sb.ToString();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
#if DEBUG
            rtbNumberList.Text = @"1.1
2.2
3.3
4.4
5.5
6.6";
            txbSumNumber.Text = "8.8";
#else
            rtbNumberList.Text = @"653165.00
356029.11
220896.45
146362.00
1847670.00
3018518.91
1347553.07
145010.74
339784.84
199350.28
1206114.00
882000.00
253246.13
720000.00
24194.07
1518952.00
139453.48
200415.00
812044.00
9032764.57
3960608.05
1855126.31
7409087.18
608094.66
225519.59
627912.23
109897.52
1215819.87
4220245.50
94299.00
96547.00
92616.01
597100.54
880440.00
343991.59
70468.19
1092418.47
66911.94
80138.65
1398551.14
172287.48
691097.86
2371693.44
3773148.63
83898.33
89922.75
2619220.46
1179477.63
3440250.98
700000.00
997545.00
272523.00
3009976.00
451891.44
2111314.00
306377.00
142329.00
2057178.00
9340.00
249027.00
60811.50
51188.50";
            txbSumNumber.Text = "35857936.42";

            
#endif
        }
     
    }
}
