﻿using System;
using System.Collections.Generic;


namespace SumNumberMatch
{

        public class PermutationAndCombination
        {
            /// <summary>
            /// 交换两个变量
            /// </summary>
            /// <param name="a">变量1</param>
            /// <param name="b">变量2</param>
            public static void Swap(ref long a, ref long b)
            {
                long temp = a;
                a = b;
                b = temp;
            }

            /// <summary>
            /// 递归算法求数组的组合(私有成员)
            /// </summary>
            /// <param name="list">返回的范型</param>
            /// <param name="t">所求数组</param>
            /// <param name="n">辅助变量</param>
            /// <param name="m">辅助变量</param>
            /// <param name="b">辅助数组</param>
            /// <param name="M">辅助变量M</param>
            private static void GetCombination(ref List<long[]> list, long[] t, long n, long m, long[] b, long M,long sum)
            {
                for (long i = n; i >= m; i--)
                {
                    b[m - 1] = i - 1;
                    if (m > 1)
                    {
                        GetCombination(ref list, t, i - 1, m - 1, b, M,sum);
                    }
                    else
                    {
                        if (list == null)
                        {
                            list = new List<long[]>();
                        }
                      
                        long result = 0;
                        for (long j = 0; j < b.Length; j++)
                        {
                            result+= t[b[j]];
                        }
                        if (result == sum)
                        {
                            long[] temp = new long[M];
                            for (long j = 0; j < b.Length; j++)
                            {
                                temp[j] = t[b[j]];
                            }
                            list.Add(temp);
                        }
                    }
                }
            }

            /// <summary>
            /// 递归算法求排列(私有成员)
            /// </summary>
            /// <param name="list">返回的列表</param>
            /// <param name="t">所求数组</param>
            /// <param name="startIndex">起始标号</param>
            /// <param name="endIndex">结束标号</param>
            private static void GetPermutation(ref List<long[]> list, long[] t, long startIndex, long endIndex)
            {
                if (startIndex == endIndex)
                {
                    if (list == null)
                    {
                        list = new List<long[]>();
                    }
                    long[] temp = new long[t.Length];
                    t.CopyTo(temp, 0);
                    list.Add(temp);
                }
                else
                {
                    for (long i = startIndex; i <= endIndex; i++)
                    {
                        Swap(ref t[startIndex], ref t[i]);
                        GetPermutation(ref list, t, startIndex + 1, endIndex);
                        Swap(ref t[startIndex], ref t[i]);
                    }
                }
            }

            /// <summary>
            /// 求从起始标号到结束标号的排列，其余元素不变
            /// </summary>
            /// <param name="t">所求数组</param>
            /// <param name="startIndex">起始标号</param>
            /// <param name="endIndex">结束标号</param>
            /// <returns>从起始标号到结束标号排列的范型</returns>
            public static List<long[]> GetPermutation(long[] t, long startIndex, long endIndex)
            {
                if (startIndex < 0 || endIndex > t.Length - 1)
                {
                    return null;
                }
                List<long[]> list = new List<long[]>();
                GetPermutation(ref list, t, startIndex, endIndex);
                return list;
            }

     



            /// <summary>
            /// 求数组中n个元素的组合
            /// </summary>
            /// <param name="t">所求数组</param>
            /// <param name="n">元素个数</param>
            /// <returns>数组中n个元素的组合的范型</returns>
            public static List<long[]> GetCombination(long[] t, long n,long sum)
            {
                if (t.Length < n)
                {
                    return null;
                }
                long[] temp = new long[n];
                List<long[]> list = new List<long[]>();
                GetCombination(ref list, t, t.Length, n, temp, n,sum);
                return list;
            }
        }
    }

